Subject: Re: [RFC PATCH v3 net-next] Documentation: devlink: Add devlink-sd

From: Jakub Kicinski <[email-masked]>
Date: Thu, 15 Feb 2024 17:58:36 -0800

On Thu, 15 Feb 2024 14:19:40 +0100 Jiri Pirko wrote:
> >Maybe the first thing to iron out is the life cycle. Right now we
> >throw all configuration requests at the driver which ends really badly
> >for those of us who deal with heterogeneous environments. Applications
> >which try to do advanced stuff like pinning and XDP break because of
> >all the behavior differences between drivers. So I don't think we
> >should expose configuration of unstable objects (those which user
> >doesn't create explicitly - queues, irqs, page pools etc) to the driver.
> >The driver should get or read the config from the core when the object
> >is created.  
> 
> I see. But again, for global objects, I understand. But this is
> device-specific object and configuration. How do you tie it up together?

We disagree how things should be modeled, sort of in principle.
I think it dates all the way back to your work on altnames.
We had the same conversation on DPLL :(

I prefer to give objects unique IDs and a bunch of optional identifying
attributes, rather than trying to build some well organized hierarchy.
The hierarchy often becomes an unnecessary constraint.